///////////////////////////////////////////
// Jet Specification File
// Defines the machine specific values
// (memory size, number of registers, etc.)
// A. Savidis, Y.Lilis.
// November, 2005.
// Project: JET Suite (Execution visualizer, Savidis, 2005).
//

#ifndef SPECS_H
#define SPECS_H

#define MEMORY_SIZE	1024

#if MEMORY_SIZE < 4 || MEMORY_SIZE % 2 != 0
#	error Memory size must be at least 4 bytes and a power of 2
#endif

#if MEMORY_SIZE > 128
#	define LARGE_MEMORY
#	define PAGE_SIZE 256
#else
#	undef LARGE_MEMORY
#	define PAGE_SIZE MEMORY_SIZE
#endif

#define TOTAL_REGISTERS 32
#define BITS_PER_REGISTER 32

// Defined when wanting to change register and 
// memory values from the visualizer...
#define SUPPLY_VISUALIZER_ACCESS_FUNCTIONS

#endif
