// ExecutionEvents.cpp
// Variables for ExecutionEvents class.
// A. Savidis, Y.Lilis.
// November, 2005.
// Project: JET Suite (Execution visualizer, Savidis, 2005).
//

#ifdef	HAS_VISUALIZER

#include "ExecutionEvents.h"

void (*ExecutionEvents::onRegAssign)	(unsigned reg, int value);
void (*ExecutionEvents::onMemAssign)	(unsigned MemCell, int value);
	
//*************************
	
void (*ExecutionEvents::onRFormat)	(const char* name, unsigned ra, unsigned rb, unsigned rc, unsigned line);
void (*ExecutionEvents::onIFormat)	(const char* name, unsigned ra, unsigned rb, int imm13, unsigned line);
void (*ExecutionEvents::onLFormat)	(const char* name, unsigned ra, int imm19, unsigned line);
	
//*************************
	
void (*ExecutionEvents::onBranch)	(const char* name, unsigned char mask, unsigned ra, unsigned rb, const char* label, unsigned line);
void (*ExecutionEvents::onJump)		(const char* name, const char* label, unsigned line);

//*************************

void (*ExecutionEvents::onProgramStart)	(void);
void (*ExecutionEvents::onProgramEnd)	(void);
void (*ExecutionEvents::onProgramError)	(const char* s);

//*************************

int			(*ExecutionEvents::outputFun)	(const char *format, ...);
const char*	(*ExecutionEvents::inputFun)	(const char* buffer, unsigned len, FILE* fp);
void		(*ExecutionEvents::cleanUpFun)	(void);

#endif	// HAS_VISUALIZER
